Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Private Attributes | List of all members
Ipopt::SymTMatrix Class Reference

Class for symmetric matrices stored in triplet format. More...

`#include <IpSymTMatrix.hpp>`

Inheritance diagram for Ipopt::SymTMatrix:
[legend]

## Public Member Functions
Constructors / Destructors
| SymTMatrix (const SymTMatrixSpace *owner_space)
| Constructor, taking the corresponding matrix space. More...
| ~SymTMatrix ()
| Destructor. More...
Changing the Values.
void | SetValues (const Number *Values)
| Set values of nonzero elements. More...
Accessor Methods
Index | Nonzeros () const
| Number of nonzero entries. More...
const Index * | Irows () const
| Obtain pointer to the internal Index array irn_ without the intention to change the matrix data (USE WITH CARE!). More...
const Index * | Jcols () const
| Obtain pointer to the internal Index array jcn_ without the intention to change the matrix data (USE WITH CARE!). More...
Number * | Values ()
| Obtain pointer to the internal Number array values_ with the intention to change the matrix data (USE WITH CARE!). More...
const Number * | Values () const
| Obtain pointer to the internal Number array values_ without the intention to change the matrix data (USE WITH CARE!). More...
Methods for providing copy of the matrix data
void | FillStruct (ipfint *Irn, ipfint *Jcn) const
| Copy the nonzero structure into provided space. More...
void | FillValues (Number *Values) const
| Copy the value data into provided space. More...
Public Member Functions inherited from Ipopt::SymMatrix
SmartPtr< const SymMatrixSpace > | OwnerSymMatrixSpace () const
| SymMatrix (const SymMatrixSpace *owner_space)
| Constructor, taking the owner_space. More...
virtual | ~SymMatrix ()
| Destructor. More...
Index | Dim () const
| Dimension of the matrix (number of rows and columns) More...
Public Member Functions inherited from Ipopt::Matrix
bool | HasValidNumbers () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
SmartPtr< const MatrixSpace > | OwnerSpace () const
| Return the owner MatrixSpace. More...
| Matrix (const MatrixSpace *owner_space)
| Constructor. More...
virtual | ~Matrix ()
| Destructor. More...
void | MultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
void | TransMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply. More...
void | AddMSinvZ (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
void | SinvBlrmZMTdBr (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Index | NRows () const
| Number of rows. More...
Index | NCols () const
| Number of columns. More...
void | ComputeRowAMax (Vector &rows_norms, bool init=true) const
| Compute the max-norm of the rows in the matrix. More...
void | ComputeColAMax (Vector &cols_norms, bool init=true) const
| Compute the max-norm of the columns in the matrix. More...
virtual void | Print (SmartPtr< const Journalist > jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print detailed information about the matrix. More...
virtual void | Print (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
Public Member Functions inherited from Ipopt::TaggedObject
| TaggedObject ()
| Constructor. More...
virtual | ~TaggedObject ()
| Destructor. More...
Tag | GetTag () const
| Users of TaggedObjects call this to update their own internal tags every time they perform the expensive operation. More...
bool | HasChanged (const Tag comparison_tag) const
| Users of TaggedObjects call this to check if the object HasChanged since they last updated their own internal tag. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const
Public Member Functions inherited from Ipopt::Subject
| Subject ()
| Default Constructor. More...
virtual | ~Subject ()
| Default destructor. More...
void | AttachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Attach the specified observer (i.e., begin recieving notifications). More...
void | DetachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Detach the specified observer (i.e., no longer recieve notifications). More...

## Protected Member Functions
Methods overloaded from matrix
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix. More...
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix. More...
Protected Member Functions inherited from Ipopt::SymMatrix
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Since the matrix is symmetric, it is only necessary to implement the MultVectorImpl method in a class that inherits from this base class. More...
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Since the matrix is symmetric, the row and column max norms are identical. More...
Protected Member Functions inherited from Ipopt::Matrix
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Protected Member Functions inherited from Ipopt::TaggedObject
void | ObjectChanged ()
| Objects derived from TaggedObject MUST call this method every time their internal state changes to update the internal tag for comparison. More...
Protected Member Functions inherited from Ipopt::Subject
void | Notify (Observer::NotifyType notify_type) const

## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| SymTMatrix ()
| Default Constructor. More...
| SymTMatrix (const SymTMatrix &)
| Copy Constructor. More...
void | operator= (const SymTMatrix &)
| Overloaded Equals Operator. More...

## Private Attributes
const SymTMatrixSpace * | owner_space_
| Copy of the owner_space ptr as a SymTMatrixSpace insteaqd of a MatrixSpace. More...
Number * | values_
| Values of nonzeros. More...
bool | initialized_
| Flag for Initialization. More...

## Additional Inherited Members
Public Types inherited from Ipopt::TaggedObject
typedef unsigned int | Tag
| Type for the Tag values. More...

## Detailed Description

Class for symmetric matrices stored in triplet format.

In the triplet format, the nonzeros elements of a symmetric matrix is stored in three arrays, Irn, Jcn, and Values, all of length Nonzeros. The first two arrays indicate the location of a non-zero element (as the row and column indices), and the last array stores the value at that location. Off-diagonal elements need to be stored only once since the matrix is symmetric. For example, the element would be stored only once, either with Irn[i]=1 and Jcn[i]=2, or with Irn[i]=2 and Jcn[i]=1. Both representations are identical. If nonzero elements (or their symmetric counter part) are listed more than once, their values are added.

The structure of the nonzeros (i.e. the arrays Irn and Jcn) cannot be changed after the matrix can been initialized. Only the values of the nonzero elements can be modified.

Note that the first row and column of a matrix has index 1, not 0.

Definition at line 42 of file IpSymTMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::SymTMatrix::SymTMatrix | ( | const SymTMatrixSpace * | owner_space | ) |

Constructor, taking the corresponding matrix space.

Ipopt::SymTMatrix::~SymTMatrix | ( |  | ) |

Destructor.

Ipopt::SymTMatrix::SymTMatrix | ( |  | ) |
| private

Default Constructor.

Ipopt::SymTMatrix::SymTMatrix | ( | const SymTMatrix & |  | ) |
| private

Copy Constructor.

## Member Function Documentation

void Ipopt::SymTMatrix::SetValues | ( | const Number * | Values | ) |

Set values of nonzero elements.

The values of the nonzero elements is copied from the incoming Number array. Important: It is assume that the order of the values in Values corresponds to the one of Irn and Jcn given to the matrix space.

Index Ipopt::SymTMatrix::Nonzeros | ( |  | ) | const
| inline

Number of nonzero entries.

Definition at line 234 of file IpSymTMatrix.hpp.

const Index * Ipopt::SymTMatrix::Irows | ( |  | ) | const
| inline

Obtain pointer to the internal Index array irn_ without the intention to change the matrix data (USE WITH CARE!).

This does not produce a copy, and lifetime is not guaranteed!

Definition at line 240 of file IpSymTMatrix.hpp.

const Index * Ipopt::SymTMatrix::Jcols | ( |  | ) | const
| inline

Obtain pointer to the internal Index array jcn_ without the intention to change the matrix data (USE WITH CARE!).

This does not produce a copy, and lifetime is not guaranteed!

Definition at line 246 of file IpSymTMatrix.hpp.

Number* Ipopt::SymTMatrix::Values | ( |  | ) |

Obtain pointer to the internal Number array values_ with the intention to change the matrix data (USE WITH CARE!).

This does not produce a copy, and lifetime is not guaranteed!

const Number* Ipopt::SymTMatrix::Values | ( |  | ) | const

Obtain pointer to the internal Number array values_ without the intention to change the matrix data (USE WITH CARE!).

This does not produce a copy, and lifetime is not guaranteed!

void Ipopt::SymTMatrix::FillStruct | ( | ipfint * | Irn,
|  | ipfint * | Jcn
| ) |  | const

Copy the nonzero structure into provided space.

void Ipopt::SymTMatrix::FillValues | ( | Number * | Values | ) | const

Copy the value data into provided space.

virtual void Ipopt::SymTMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const
| protected virtual

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::SymTMatrix::HasValidNumbersImpl | ( |  | ) | const
| protected virtual

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::SymTMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init
| ) |  | const
| protected virtual

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::SymTMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix
| ) |  | const
| protected virtual

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::SymTMatrix::operator= | ( | const SymTMatrix & |  | ) |
| private

Overloaded Equals Operator.

## Member Data Documentation

const SymTMatrixSpace* Ipopt::SymTMatrix::owner_space_
| private

Copy of the owner_space ptr as a SymTMatrixSpace insteaqd of a MatrixSpace.

Definition at line 147 of file IpSymTMatrix.hpp.

Number* Ipopt::SymTMatrix::values_
| private

Values of nonzeros.

Definition at line 150 of file IpSymTMatrix.hpp.

bool Ipopt::SymTMatrix::initialized_
| private

Flag for Initialization.

Definition at line 153 of file IpSymTMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/TMatrices/IpSymTMatrix.hpp